<?php
namespace Services;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\PCP\Services\RateioReceitaDestinosService as rateio;

class ReceitasSolicitacaoCheckListEmergencialService {
    
    protected $connection;
    protected $rateioService;
    
    public function __construct($connection, $rateioService) {
        
        $this->connection = $connection;
        $this->rateioService = $rateioService;
        
    }
    
    public function calcNewDestinationRecipeAmount($row){
        
        $destinatinos = self::getRecipeDestinations($row["NRRECSOLEMERGPROD"]);
        
        $this->rateioService->setOriginColumns("QTRECEITA");
        $this->rateioService->setAffectedColumns("QTRECEITA");
        $newDestinations = $this->rateioService->calcRateio($row, $destinatinos);
        
        forEach($newDestinations as $destination){
            self::setNewDestinationRecipeAmount($destination["NRDESTSOLEMERGPROD"], $destination["QTRECEITA"]);
        }
        
    }
    
    public function getRecipeDestinations($nrrecsolemergprod){
        
        $selectParams = array(
            "NRRECSOLEMERGPROD" => $nrrecsolemergprod
        );
        
        $select = "SELECT NRDESTSOLEMERGPROD, QTRECEITA
                    FROM DESTSOLEMERGPROD
                    WHERE NRRECSOLEMERGPROD = :NRRECSOLEMERGPROD";
        
        try{
            
            $std = $this->connection->prepare($select);
            $std->execute($selectParams);
            $destinatinos = $std->fetchAll();
            
            return $destinatinos;
            
        } catch (Exception $e){
            throw $e;
        }
        
    }
    
    public function setNewDestinationRecipeAmount($nrdestsolemergprod, $newValue){
        
        $updateParams = array(
            "NRDESTSOLEMERGPROD"    => $nrdestsolemergprod,
            "QTRECEITA"             => $newValue
        );
        $update = "UPDATE DESTSOLEMERGPROD
                    SET QTRECEITA = :QTRECEITA
                    WHERE NRDESTSOLEMERGPROD = :NRDESTSOLEMERGPROD";
        
        try{
            $std = $this->connection->prepare($update);
            $std->execute($updateParams);
            
        } catch (Exception $e){
            throw $e;
        }
        
    }
    
}